var selectedCpt=-1;
var tReacPos=[];
var tCpt=[];

function simplifieCpt () {
	// calcul de la balance
	for (var c of tCpt) {
		var nbProd=0;
		var bal=0;
		for (var r of c.tReac) {
			if ((r*1)>0) {bal--;}
		}
		for (var p of c.tProd) {
			if ((p*1)>0) {bal++;nbProd++;}
		}
		c.bal=bal;
		c.nbProd=nbProd;
	}
	
	// nombre de cases vides imposées dans les réactifs
	for (var c of tCpt) {
		var ncv=0;
		for (var r of c.tReac) {
			if (r=="0") {ncv++;}
		}
		c.ncv=ncv;
	}
}

function clicRetraitCpt() {
	if (selectedCpt<0) {return false}
	var cpt=tCpt[selectedCpt];
	swal({
		  title: 'Suppression',
		  text: "Etes vous sûr de vouloir supprimer la règle nommée "+cpt.nom+" ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			tCpt.splice(selectedCpt,1);
			refreshListeCpt();
		  } else {
			return false;
		  }
	})
}

function removeCptContenantEntId (id) {
	id+="";
	// on marque les cpt à supprimer
	for (let c of tCpt) {
		let r=c.tReac;
		let p=c.tProd;
		let ri=r.indexOf(id);
		let pi=p.indexOf(id);
		if ((ri>=0)||(pi>=0)) {
			c.nom="";
		}
		if (c.condEff) {
			if (c.condEffAg==id) { // si le cpt est conditionné à l'effectif de id
				c.nom=""; 
			}
		}
	}
	
	// on supprime ce qui a été marqué
	var ntCpt=tCpt.filter(r => r.nom!="");
	tCpt=JSON.parse(JSON.stringify(ntCpt));
	refreshListeCpt();
	simplifieCpt();
}

function clickButDupliquerComportement () {
	if (selectedCpt<0) {return false}
	let cpt=JSON.parse(JSON.stringify(tCpt[selectedCpt])); // deep clone
	// attribution d'un nom unique
	let maxl=inputNomComportement.maxLength;
	let nn=1;
	let nom=cpt.nom;
	while (tCpt.some(c=>c.nom==nom)) {
		nn++;
		let suffixe="#"+nn;
		nom=cpt.nom+suffixe;
		if (nom.length>maxl) { // nom plus long que le champ de saisie
			nom=nom.substr(0,maxl-suffixe.length)+suffixe;		
		}
	}
	cpt.nom=nom;
	ajouteComportement(cpt);
}

function suspendreCpt () {
	if (selectedCpt<0) {return false}
	tCpt[selectedCpt].susp=!tCpt[selectedCpt].susp;
	refreshListeNomCpt();
	selectCpt(selectedCpt);
}

function clickButEditComportement() {
	if (selectedCpt<0) {return false}
	
	affModale('divSaisieComportement');
	
	if (tZon.length==0) {
		hideId("divZoneCpt");
	} else {
		showId("divZoneCpt");
	}
	
	var cpt=tCpt[selectedCpt];
	changeTypeCpt(cpt.type);
	byId("inputNomComportement").value=cpt.nom;	
	byId("selectTypeCpt").value=cpt.type;
			
	updateTableauxReacProd();
	refreshListeZonesCpt();
	
	checkReglEff.checked=cpt.condEff;
	checkMultiplProba.checked=cpt.multiplProba;
	if (cpt.condEff===true) {
		showId("divReglEff2");
		byId("inputEffReg").value=cpt.condEffVal;
		byId("selectInfSup").value=cpt.condEffTyp;
		byId("selectAgentEff").value=cpt.condEffAg;	
	} else {
		hideId("divReglEff2");	
	}	
	
	byId("selectTypeZoneCpt").value=cpt.zone;
	byId("selectTypeZoneCpt2").value=cpt.zone2;
		
	if (cpt.type=="spont") {
		byId("inputProbaSpont").value=cpt.probaSpont*1;
		byId("inputNombreProbaSpont").value=cpt.nbSpont*1;
		changeProbaSpont ();
		for (var n=1;n<6;n++) {
			var prod=cpt.tProd[n-1]||"";
			if (prod!="") {
				byId("selectProdS"+n).selectedIndex=getEntIndexById(prod*1)+1;
			}
		}
	} 

	// mise à jour réactifs et produits
	if (cpt.type=="reaction") {
		byId("checkCtr").checked=cpt.ctr;
		byId("inputAgeDelai").value=cpt.delai*1;
		byId("inputProbaReac").value=cpt.proba*1;
		for (var n=1;n<6;n++) {
			byId("checkLink"+n).checked=cpt.tLink[n-1];
			byId("checkKeep"+n).checked=cpt.tKeep[n-1];
			var reac=cpt.tReac[n-1]||"";
			if (reac!="") {
				byId("selectReac"+n).value=reac;
			} else {
				byId("selectReac"+n).value="-1";
			}
			var prod=cpt.tProd[n-1]||"";
			if (prod!="") {
				byId("selectProd"+n).selectedIndex=getEntIndexById(prod*1)+1;
			} else {
				byId("selectProd"+n).value="-1";	
			}
		}
	}
	
	byId("butSaisieComportement").innerHTML="Appliquer";
	byId("divTitreSaisieCpt").innerHTML="<b>Modifier une règle</b>";
	byId("butAnnulerComportement").innerHTML="Annuler la modification";
}

function changeTypeCpt (v) {
	for (var n=1;n<6;n++) {
		var sr=byId("selectReac"+n);
		var sp=byId("selectProd"+n);
		var sps=byId("selectProdS"+n);
		sr.selectedIndex=0;
		sp.selectedIndex=0;
		sps.selectedIndex=0;
		byId("checkKeep"+n).checked=false;
		byId("checkLink"+n).checked=false;
	}
		
	byId("checkCtr").checked=true;
	byId("inputProbaReac").value=25;
	byId("inputAgeDelai").value=0;
	
	byId("inputProbaSpont").value=50;
	changeProbaSpont ();
	
	if (v=="reaction") {
		showId("divRebornProduits");
		showId("tableReaction");
		hideId("tableSpont");
		showId ("divProbaReac");
		showId ("divAgeDelai");
		hideId ("divProbaSpont");
		showId ("selectReac2");
		showId ("selectReac3");
		showId ("selectReac4");
	} else if (v=="spont") {
		hideId("divRebornProduits");
		showId("tableSpont");
		hideId("tableReaction");
		hideId ("divProbaReac");
		hideId ("divAgeDelai");
		showId ("divProbaSpont");
	} 
	
}

function clicAjoutCpt () {
	byId("selectTypeCpt").value="reaction";
	
	if (tZon.length==0) {
		hideId("divZoneCpt");
	} else {
		showId("divZoneCpt");
	}
	
	changeTypeCpt("reaction");
	byId("inputNomComportement").value="";
	
	byId("checkReglEff").checked=false;
	hideId("divReglEff2");
	byId("selectAgentEff").selectedIndex=0;
	byId("selectInfSup").value="inf";
	byId("inputEffReg").value=10;
	
	byId("butSaisieComportement").innerHTML="Ajouter cette règle";
	byId("butAnnulerComportement").innerHTML="Annuler";
	byId("divTitreSaisieCpt").innerHTML="<b>Ajouter une nouvelle règle</b>";
	affModale('divSaisieComportement');
	refreshListeZonesCpt();
	updateTableauxReacProd();
}


function butOKsaisieComportement () {
	var nom=byId("inputNomComportement").value;
	var zone=byId("selectTypeZoneCpt").value*1;
	var zone2=byId("selectTypeZoneCpt2").value*1;
	var type=byId("selectTypeCpt").value;
	if (nom=="") {nom="Comportement n°"+(tCpt.length+1);}
	var cpt={};
	cpt.nom=nom;
	cpt.type=type;
	cpt.zone=zone;
	cpt.zone2=zone2;
	cpt.condEff=checkReglEff.checked;
	cpt.multiplProba=checkMultiplProba.checked;
	if (cpt.condEff===true) {
		cpt.condEffVal=inputEffReg.value*1;
		cpt.condEffTyp=selectInfSup.value;
		cpt.condEffAg=selectAgentEff.value*1;		
	}
	
	if (type=="reaction") {
		// ajout des réactifs et produits
		cpt.delai=byId("inputAgeDelai").value*1;
		cpt.ctr=byId("checkCtr").checked;
		var tProd=[];
		var tReac=[];
		var tLink=[];
		var tKeep=[];
		for (var n=1;n<6;n++) {
			var lk=byId("checkLink"+n).checked;
			var k=byId("checkKeep"+n).checked;
			var reac=byId("selectReac"+n).value;
			var prod=byId("selectProd"+n).value;
			if (reac!="-1") {tReac.push(reac)} else {tReac.push("")}
			if (prod!="-1") {tProd.push(prod)} else {tProd.push("")}
			tLink.push(lk);
			tKeep.push(k);
		}
		cpt.tProd=tProd;
		cpt.tReac=tReac;
		cpt.tLink=tLink;
		cpt.tKeep=tKeep;
		cpt.proba=byId("inputProbaReac").value*1;
		if (tReac.length==0) {
			swal({
			  type: 'error',
			  title: 'Erreur...',
			  text: "Aucun réactif n'a été saisi.",
			});
			return false;
		}
	};
	
	if (type=="spont") {
		// ajout des réactifs et produits
		cpt.probaSpont=byId("inputProbaSpont").value*1;
		cpt.nbSpont=byId("inputNombreProbaSpont").value*1;
		var tProd=[];
		var tReac=[];
		for (var n=1;n<6;n++) {
			var prod=byId("selectProdS"+n).value;
			if (prod!="-1") {tProd.push(prod)}
		}
		cpt.tProd=tProd;
		cpt.tReac=tReac;
	}
	
	// on retire le link si le réactif est vide
	for (let n=0;n<5;n++) {
		if ((cpt.tReac[n]=="")||(cpt.tReac[n]=="0")||(cpt.tReac[n]=="#")) {
			cpt.tLink[n]=false;
		}
	}
	
	cacheModale();	
	hideId("divSaisieComportement");
	
	// on regarde la première lettre A comme ajouter
	if (byId("butSaisieComportement").innerHTML[1]=="j") {
		cpt.susp=false;
		ajouteComportement(cpt);
	} else {
		cpt.susp=tCpt[selectedCpt].susp;
		modifieComportement(cpt);
	}
}

function modifieComportement (cpt) {
	tCpt[selectedCpt]=JSON.parse(JSON.stringify(cpt));
	refreshListeCpt();
}

function ajouteComportement(cpt) {
	tCpt.push(cpt);
	refreshListeCpt();
	divListeRegles.scrollTop = divListeRegles.scrollHeight; // scroll tout en bas de la liste
}

function effaceSelCpt () {
	for (let i=0;i<tCpt.length;i++) {
		let s=byId ("spanListeCpt"+i);
		s.style.backgroundColor="white";
		s.style.color="black";
	}
}

function selectCpt (i) {
	effaceSelCpt();
	selectedCpt=i;
	byId("spanSusp").innerHTML="Suspendre cette règle";
	
	if (i>=0) {
		if (tCpt[i].susp===true) {
			byId("spanSusp").innerHTML="Réactiver cette règle";
		}
		let s=byId ("spanListeCpt"+i);
		s.style.backgroundColor="#666";
		s.style.color="white";
	} 
}

function refreshListeNomCpt() {
	for (let i=0;i<tCpt.length;i++) {
		let spa=byId("spanListeCpt"+i);
		let susp="";
		if (tCpt[i].susp===true) {
			susp="<div style='display:inline-block;width:0.9em;height:0.9em;background-image: url(\"images/suspend.png\");background-size: contain;'></div>";
		} else {
			susp="";
		}
		spa.innerHTML=susp+tCpt[i].nom;
	}
}

function refreshListeCpt() {
	var d=byId("divListeRegles");
	t="";
	for (let i=0;i<tCpt.length;i++) {
		let c=tCpt[i];
		if (c.susp===true) {col="color:#AAA;"}
		t+="<div id=\"spanListeCpt"+i+"\" style=\"cursor:pointer;padding-left:0.2em;width:100%;\" ";
		t+="onclick=\"selectCpt("+i+")\" ";
		t+="ondblclick=\"clickButEditComportement()\" "
		t+=">";
		t+="</div>";
	}
	d.innerHTML=t;
	refreshListeNomCpt();
	simplifieCpt();
}

function checkEffCondCpt (cpt) {
	if (cpt.condEff===false) {return true;}
	let nInd;
	if (cpt.condEffAg>0) {nInd=entById(cpt.condEffAg).tInd.length;} else {nInd=nbCasesVides;}
	if ((cpt.condEffTyp)=="egal") {
		if (nInd!=cpt.condEffVal) {
			return false;
		}
	}
	if ((cpt.condEffTyp)=="diff") {
		if (nInd==cpt.condEffVal) {
			return false;
		}
	}
	if ((cpt.condEffTyp)=="sup") {
		if (nInd<=cpt.condEffVal) {
			return false;
		}
	}
	if ((cpt.condEffTyp)=="inf") {
		if (nInd>=cpt.condEffVal) {
			return false;
		}
	}		
	return true;
}

function changeProbaSpont () {
	var v=byId("inputProbaSpont").value*1;
	if (v==100) {
		showId("divNombreProbaSpont");
	} else {
		hideId("divNombreProbaSpont");
	}
}

function checkCondEff (c) {
	if (c) {
		showId("divReglEff2");
	} else {
		hideId("divReglEff2");	
	}
}
