
function checkReacPossible (cpt,x,y,id) {
	// on vérifie si la règle "cpt" est possible en x y avec l'entité id
	//console.log ("checking ",x,y,id);
	if (damier[x][y]!=id) {
		//console.log ("damier x y n'est pas ",id);
		return false;
	} 
	
	if (cpt.zone>=0) {
		if (cpt.zone!=damierZ[x][y]) {
			return false;
		}
	}
	
	if (checkEffCondCpt(cpt)===false) {
		return false;
	}

	var ent=entById(id);
	var ageMin=cpt.delai;

	
	if ((cpt.ctr===true)&&(cpt.tReac[0]!=id)) {return false;}  // si la case "le premier réactif au centre" est cochée
	
	var proba=cpt.proba;
		
	var reac=cpt.tReac.slice();
	var voisins=voisinsAutourDe(x,y);
	
	// y a-t-il de la place dans le voisinage
	if (voisins.filter(vo=>vo.id===0).length<cpt.bal) {return false;}
	
	// si des cases vides sont imposées dans les réactifs, y en a-t-il assez ?
	if (cpt.ncv>0) {
		if (voisins.filter(vo=>vo.id===0).length<cpt.ncv) {return false;}
	}
	
		
	// on simule la réaction
	var erreur=false;
	
	for (let r of reac) {
		if ((r[0]!="#")&&(r!="0")&&(r!="")) {
			// on retire un voisin de cet id
			let nv = voisins.findIndex(vo => vo.id === r*1);
			if (nv<0) {erreur=true;break;}
			if (indByXYandId(voisins[nv].x,voisins[nv].y,voisins[nv].id).age<ageMin) {erreur=true;break;}
			voisins[nv].id=0;
		}
	}
	
	if (erreur) {return false;}
	
	// reste-t-il assez de place pour les produits ?
	let casesVides=voisins.filter(vo=>vo.id===0);
	if (casesVides.length<cpt.nbProd) {
		// pas de place
		return false;
	}
	
	// tout semble OK
	return true;

}

//var tCt=[];
//tCt[0]=0;
//tCt[1]=0;
//tCt[2]=0;

function checkReactionsPossibles (i,j) {
	// i = numéro entité
	// j = numéro individu
	var ent=tEnt[i];
	var id=ent.id;
	var ind=ent.tInd[j];
	var x=ind.x;
	var y=ind.y;

	
	for (var k=0;k<tCpt.length;k++) {
		let cpt=tCpt[k];
		if (cpt.susp===false) {
			if (cpt.type=="reaction") {
				if (checkReacPossible (cpt,x,y,id)===true) {
					tReacPos.push({iCpt:k,x:x,y:y,id:id});
					//tCt[k]++;
					//console.log (tCt[0],tCt[1],tCt[2]);
				}	
			}
		}
	}
}

function testGenSpont () {
	function ajouteUneGenSpont(prod,zone,zone2) {
		let nProd=prod.length;
		
		if ((prod.length==0)&&(zone2>=0)) {
			// seulement changement de zone
			let c=findCaseVideZone(zone);
			if (c.x>=0) {
				damierZ[c.x][c.y]=zone2;
				zonesChanged=true;
			}
		} else {
			// génération spontanée d'agents
			for (var i=0;i<prod.length;i++) {
				let p=prod[i];
				if (p!="") {
					let c=findCaseVideZone(zone);
					if (c.x>=0) {
						rajouteEnt (p*1,c.x,c.y);
						if (zone2>=0) {
							damierZ[c.x][c.y]=zone2;
							zonesChanged=true;
						}
					}
				}
			}
		}		
	}
	
	
	for (var k=0;k<tCpt.length;k++) {
		let cpt=tCpt[k];
		if ((cpt.type=="spont")&&(cpt.susp===false)&&(checkEffCondCpt(cpt))) {
			if (cpt.probaSpont==100) {
				// plusieurs gen
				for (var j=0;j<cpt.nbSpont;j++) {
					 ajouteUneGenSpont(cpt.tProd,cpt.zone,cpt.zone2);
				}
			} else {
				// une seule gen mais improbable
				let probaSpont=cpt.probaSpont/100;
				if (cpt.multiplProba) {
					if (cpt.zone==-1) { // n'importe quelle zone
						probaSpont*=nbLig*nbCol;
					} else { 
						probaSpont*=calcSurfaceZone(cpt.zone);
					}
				}
				if (Math.random()<probaSpont) {
					 ajouteUneGenSpont(cpt.tProd,cpt.zone,cpt.zone2);
				}
			}
		}
	}	
}


function testReactions () {
	// on vérifie les réactions possibles dans une première passe
	tReacPos=[];
	
	for (let i=0;i<tEnt.length;i++) {
		let ent=tEnt[i];
		for (let j=0;j<ent.tInd.length;j++) {
			checkReactionsPossibles(i,j);
		}
	}
}

function doReactions () {
	// 2ème passe
	//return false;
	
	// on mélange le tableau des comportements possibles
	shuffle(tReacPos);
	
	for (var cptPos of tReacPos) {
		let iCpt=cptPos.iCpt;
		let cpt=tCpt[iCpt];
		let id=cptPos.id;
		let x=cptPos.x;
		let y=cptPos.y;
		doReaction (cpt,x,y,id);
	}
}

function doReaction (cpt,x,y,id) {
	if ((Math.random()*100)>cpt.proba)  {return false;}
	// si il n'y a pas assez de place pour tout accueillir, on laisse tomber
	//console.log ("do reaction ",x,y,id);	
	if (nbMaxInd>0) {
		if ((nbTotalInd()+cpt.bal)>=nbMaxInd) {
			//console.log ("pas assez de place !");
			return false;
		}
	}
	
	if (checkReacPossible(cpt,x,y,id)===true) {
		var reac=cpt.tReac.slice();
		var prod=cpt.tProd.slice();
		var lk=cpt.tLink.slice(); // le produit n°2 sera à l'emplacement du réactif n°2 etc.
		var keep=cpt.tKeep.slice();
		
		// on stocke dans un tableau les positions des futurs produits (si lk est coché)
		// et leur ages (si keep est coché)
		var tPosProd=[];
		var tAge=[];
		
		
		// on commence par initialiser le tableau
		for (let i=0;i<5;i++) {
			tPosProd[i]={x:0,y:0}
		}
				
		// on commence par les spécifiques
		for (let i=0;i<reac.length;i++) {
			let r=reac[i];
			if ((r[0]!="#")&&(r!="0")&&(r!="")) { // on ignore les réacs inexistants ou correspondant à des cases vides
				// on recueille dans un tableau les voisins restant autour de x,y (inclus)
				let voisins=voisinsAutourDe(x,y);
				shuffleSaufPremier(voisins); // la case centrale sera toujours prioritaire et sera choisie en premier si elle contient un réactif
				let v=voisins.find(vo => vo.id === r*1); // le premier trouvé de la liste sera retenu
				tPosProd[i].x=v.x;
				tPosProd[i].y=v.y;
				let age=destroyEnt (v.x,v.y);
				//console.log ("destroy ",v.x,v.y);
				tAge[i]=age;
			}
		}
		
		
		if (prod.length>0) {
			// on rajoute les produits
			// on commence par ceux qui sont linkés (place fixée) 
			for (let i=0;i<prod.length;i++) {
				if (prod[i]!="") {
					if (lk[i]===true) {
						let age=0;
						if (keep[i]===true) {age=tAge[i];}
						rajouteEnt (prod[i]*1,tPosProd[i].x,tPosProd[i].y,age);
					} 
				}
			}
			// on finit par ceux qui sont en placement libre
			for (let i=0;i<prod.length;i++) {
				if (prod[i]!="") {
					if (lk[i]!==true) {
						let cv=placesLibresAutourDe(x,y);
						shuffle(cv);
						rajouteEnt (prod[i]*1,cv[0].x,cv[0].y,0);
					}
				}
			}
		}
		// changement de zone ?
		if (cpt.zone2>=0) {
			damierZ[x][y]=cpt.zone2;
			zonesChanged=true;
		}
	} else {
		//console.log ("reaction pas possible !");
	}


}

